Package com.fasterxml.jackson.core

# Class JsonParser

java.lang.Object
com.fasterxml.jackson.core.JsonParser

All Implemented Interfaces:
  `Versioned`, `Closeable`, `AutoCloseable`

Direct Known Subclasses:
  `JsonParserDelegate`, `ParserMinimalBase`

public abstract class JsonParser extends Object implements Closeable, Versioned
Base class that defines public API for reading JSON content. Instances are created using factory methods of a `JsonFactory` instance.

Author:
  Tatu Saloranta

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static enum`
`JsonParser.Feature`
Enumeration that defines all on/off features for parsers.
`static enum`
`JsonParser.NumberType`
Enumeration of possible "native" (optimal) types that can be used for numbers.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected int`
`_features`
Bit flag composed of bits that indicate which `JsonParser.Feature`s are enabled.
`protected RequestPayload`
`_requestPayload`
Optional container that holds the request payload which will be displayed on JSON parsing error.
`protected static final JacksonFeatureSet<StreamReadCapability>`
`DEFAULT_READ_CAPABILITIES`
Default set of `StreamReadCapability`ies that may be used as basis for format-specific readers (or as bogus instance if non-null set needs to be passed).

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`JsonParser()`
`protected`
`JsonParser(int features)`

## Method Summary

Modifier and Type
Method
Description
`protected ObjectCodec`
`_codec()`
`protected JsonParseException`
`_constructError(String msg)`
Helper method for constructing `JsonParseException`s based on current state of the parser
`protected JsonParseException`
`_constructReadException(String msg)`
Helper method for constructing `JsonParseException` based on current state of the parser.
`protected JsonParseException`
`_constructReadException(String msg, Object arg)`
`protected JsonParseException`
`_constructReadException(String msg, Object arg1, Object arg2)`
`protected JsonParseException`
`_constructReadException(String msg, Object arg1, Object arg2, Object arg3)`
`protected JsonParseException`
`_constructReadException(String msg, Throwable t)`
Helper method for constructing `JsonParseException` based on current state of the parser and indicating that the given `Throwable` is the root cause.
`protected void`
`_reportUnsupportedOperation()`
Helper method to call for operations that are not supported by parser implementation.
`void`
`assignCurrentValue(Object v)`
Helper method, usually equivalent to: `getParsingContext().setCurrentValue(v);`
`boolean`
`canParseAsync()`
Method that can be called to determine if this parser instance uses non-blocking ("asynchronous") input access for decoding or not.
`boolean`
`canReadObjectId()`
Introspection method that may be called to see if the underlying data format supports some kind of Object Ids natively (many do not; for example, JSON doesn't).
`boolean`
`canReadTypeId()`
Introspection method that may be called to see if the underlying data format supports some kind of Type Ids natively (many do not; for example, JSON doesn't).
`boolean`
`canUseSchema(FormatSchema schema)`
Method that can be used to verify that given schema can be used with this parser (using `setSchema(com.fasterxml.jackson.core.FormatSchema)`).
`abstract void`
`clearCurrentToken()`
Method called to "consume" the current token by effectively removing it so that `hasCurrentToken()` returns false, and `getCurrentToken()` null).
`abstract void`
`close()`
Closes the parser so that no further iteration or data access can be made; will also close the underlying input source if parser either owns the input source, or feature `JsonParser.Feature.AUTO_CLOSE_SOURCE` is enabled.
`JsonParser`
`configure(JsonParser.Feature f, boolean state)`
Method for enabling or disabling specified feature (check `JsonParser.Feature` for list of features)
`JsonLocation`
`currentLocation()`
Method that returns location of the last processed input unit (character or byte) from the input; usually for error reporting purposes.
`String`
`currentName()`
Method that can be called to get the name associated with the current token: for `JsonToken.FIELD_NAME`s it will be the same as what `getText()` returns; for field values it will be preceding field name; and for others (array values, root-level values) null.
`JsonToken`
`currentToken()`
Accessor to find which token parser currently points to, if any; null will be returned if none.
`int`
`currentTokenId()`
Method similar to `getCurrentToken()` but that returns an `int` instead of `JsonToken` (enum value).
`JsonLocation`
`currentTokenLocation()`
Method that return the starting location of the current (most recently returned) token; that is, the position of the first input unit (character or byte) from input that starts the current token.
`Object`
`currentValue()`
Helper method, usually equivalent to: `getParsingContext().getCurrentValue();`
`JsonParser`
`disable(JsonParser.Feature f)`
Method for disabling specified feature (check `JsonParser.Feature` for list of features)
`JsonParser`
`enable(JsonParser.Feature f)`
Method for enabling specified parser feature (check `JsonParser.Feature` for list of features)
`void`
`finishToken()`
Method that may be used to force full handling of the current token so that even if lazy processing is enabled, the whole contents are read for possible retrieval.
`abstract BigInteger`
`getBigIntegerValue()`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can not be used as a Java long primitive type due to its magnitude.
`byte[]`
`getBinaryValue()`
Convenience alternative to `getBinaryValue(Base64Variant)` that defaults to using `Base64Variants.getDefaultVariant()` as the default encoding.
`abstract byte[]`
`getBinaryValue(Base64Variant bv)`
Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value.
`boolean`
`getBooleanValue()`
Convenience accessor that can be called when the current token is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE`, to return matching `boolean` value.
`byte`
`getByteValue()`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java byte primitive type.
`abstract ObjectCodec`
`getCodec()`
Accessor for `ObjectCodec` associated with this parser, if any.
`abstract JsonLocation`
`getCurrentLocation()`
Alias for `currentLocation()`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).
`abstract String`
`getCurrentName()`
Alias of `currentName()`.
`abstract JsonToken`
`getCurrentToken()`
Alias for `currentToken()`, may be deprecated sometime after Jackson 2.13 (will be removed from 3.0).
`abstract int`
`getCurrentTokenId()`
Deprecated.
Since 2.12 use `currentTokenId()` instead
`Object`
`getCurrentValue()`
Alias for `currentValue()`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).
`abstract BigDecimal`
`getDecimalValue()`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` or `JsonToken.VALUE_NUMBER_INT`.
`abstract double`
`getDoubleValue()`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java double primitive type.
`Object`
`getEmbeddedObject()`
Accessor that can be called if (and only if) the current token is `JsonToken.VALUE_EMBEDDED_OBJECT`.
`int`
`getFeatureMask()`
Bulk access method for getting state of all standard `JsonParser.Feature`s.
`abstract float`
`getFloatValue()`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java float primitive type.
`int`
`getFormatFeatures()`
Bulk access method for getting state of all `FormatFeature`s, format-specific on/off configuration settings.
`Object`
`getInputSource()`
Method that can be used to get access to object that is used to access input being parsed; this is usually either `InputStream` or `Reader`, depending on what parser was constructed with.
`abstract int`
`getIntValue()`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java int primitive type.
`abstract JsonToken`
`getLastClearedToken()`
Method that can be called to get the last token that was cleared using `clearCurrentToken()`.
`abstract long`
`getLongValue()`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a Java long primitive type.
`NonBlockingInputFeeder`
`getNonBlockingInputFeeder()`
Method that will either return a feeder instance (if parser uses non-blocking, aka asynchronous access); or `null` for parsers that use blocking I/O.
`abstract JsonParser.NumberType`
`getNumberType()`
If current token is of type `JsonToken.VALUE_NUMBER_INT` or `JsonToken.VALUE_NUMBER_FLOAT`, returns one of `JsonParser.NumberType` constants; otherwise returns null.
`abstract Number`
`getNumberValue()`
Generic number value accessor method that will work for all kinds of numeric values.
`Object`
`getNumberValueDeferred()`
Method similar to `getNumberValue()` but that returns either same `Number` value as `getNumberValue()` (if already decoded), or `String` representation of as-of-yet undecoded number.
`Number`
`getNumberValueExact()`
Method similar to `getNumberValue()` with the difference that for floating-point numbers value returned may be `BigDecimal` if the underlying format does not store floating-point numbers using native representation: for example, textual formats represent numbers as Strings (which are 10-based), and conversion to `Double` is potentially lossy operation.
`Object`
`getObjectId()`
Method that can be called to check whether current token (one that was just read) has an associated Object id, and if so, return it.
`abstract JsonStreamContext`
`getParsingContext()`
Method that can be used to access current parsing context reader is in.
`JacksonFeatureSet<StreamReadCapability>`
`getReadCapabilities()`
Accessor for getting metadata on capabilities of this parser, based on underlying data format being read (directly or indirectly).
`FormatSchema`
`getSchema()`
Method for accessing Schema that this parser uses, if any.
`short`
`getShortValue()`
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java short primitive type.
`abstract String`
`getText()`
Method for accessing textual representation of the current token; if no current token (before first call to `nextToken()`, or after encountering end-of-input), returns null.
`int`
`getText(Writer writer)`
Method to read the textual representation of the current token in chunks and pass it to the given Writer.
`abstract char[]`
`getTextCharacters()`
Method similar to `getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information.
`abstract int`
`getTextLength()`
Accessor used with `getTextCharacters()`, to know length of String stored in returned buffer.
`abstract int`
`getTextOffset()`
Accessor used with `getTextCharacters()`, to know offset of the first text content character within buffer.
`abstract JsonLocation`
`getTokenLocation()`
Alias for `currentTokenLocation()`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).
`Object`
`getTypeId()`
Method that can be called to check whether current token (one that was just read) has an associated type id, and if so, return it.
`boolean`
`getValueAsBoolean()`
Method that will try to convert value of current token to a boolean.
`boolean`
`getValueAsBoolean(boolean def)`
Method that will try to convert value of current token to a boolean.
`double`
`getValueAsDouble()`
Method that will try to convert value of current token to a Java double.
`double`
`getValueAsDouble(double def)`
Method that will try to convert value of current token to a Java double.
`int`
`getValueAsInt()`
Method that will try to convert value of current token to a Java `int` value.
`int`
`getValueAsInt(int def)`
Method that will try to convert value of current token to a int.
`long`
`getValueAsLong()`
Method that will try to convert value of current token to a long.
`long`
`getValueAsLong(long def)`
Method that will try to convert value of current token to a long.
`String`
`getValueAsString()`
Method that will try to convert value of current token to a `String`.
`abstract String`
`getValueAsString(String def)`
Method that will try to convert value of current token to a `String`.
`abstract boolean`
`hasCurrentToken()`
Method for checking whether parser currently points to a token (and data for that token is available).
`abstract boolean`
`hasTextCharacters()`
Method that can be used to determine whether calling of `getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.
`abstract boolean`
`hasToken(JsonToken t)`
Method that is functionally equivalent to: `return currentToken() == t` but may be more efficiently implemented.
`abstract boolean`
`hasTokenId(int id)`
Method that is functionally equivalent to: `return currentTokenId() == id` but may be more efficiently implemented.
`abstract boolean`
`isClosed()`
Method that can be called to determine whether this parser is closed or not.
`boolean`
`isEnabled(JsonParser.Feature f)`
Method for checking whether specified `JsonParser.Feature` is enabled.
`boolean`
`isEnabled(StreamReadFeature f)`
Method for checking whether specified `JsonParser.Feature` is enabled.
`boolean`
`isExpectedNumberIntToken()`
Similar to `isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.VALUE_NUMBER_INT`.
`boolean`
`isExpectedStartArrayToken()`
Specialized accessor that can be used to verify that the current token indicates start array (usually meaning that current token is `JsonToken.START_ARRAY`) when start array is expected.
`boolean`
`isExpectedStartObjectToken()`
Similar to `isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.START_OBJECT`.
`boolean`
`isNaN()`
Access for checking whether current token is a numeric value token, but one that is of "not-a-number" (NaN) variety (including both "NaN" AND positive/negative infinity!): not supported by all formats, but often supported for `JsonToken.VALUE_NUMBER_FLOAT`.
`Boolean`
`nextBooleanValue()`
Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE` returns matching Boolean value; otherwise return null.
`String`
`nextFieldName()`
Method that fetches next token (as if calling `nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME`; if it is, returns same as `getCurrentName()`, otherwise null.
`boolean`
`nextFieldName(SerializableString str)`
Method that fetches next token (as if calling `nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME` with specified name and returns result of that comparison.
`int`
`nextIntValue(int defaultValue)`
Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 32-bit int value; otherwise returns specified default value It is functionally equivalent to:
`long`
`nextLongValue(long defaultValue)`
Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 64-bit long value; otherwise returns specified default value It is functionally equivalent to:
`String`
`nextTextValue()`
Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_STRING` returns contained String value; otherwise returns null.
`abstract JsonToken`
`nextToken()`
Main iteration method, which will advance stream enough to determine type of the next token, if any.
`abstract JsonToken`
`nextValue()`
Iteration method that will advance stream enough to determine type of the next token that is a value type (including JSON Array and Object start/end markers).
`abstract void`
`overrideCurrentName(String name)`
Method that can be used to change what is considered to be the current (field) name.
`JsonParser`
`overrideFormatFeatures(int values, int mask)`
Bulk set method for (re)setting states of `FormatFeature`s, by specifying values (set / clear) along with a mask, to determine which features to change, if any.
`JsonParser`
`overrideStdFeatures(int values, int mask)`
Bulk set method for (re)setting states of features specified by `mask`.
`int`
`readBinaryValue(Base64Variant bv, OutputStream out)`
Similar to `readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.
`int`
`readBinaryValue(OutputStream out)`
Method that can be used as an alternative to `getBigIntegerValue()`, especially when value can be large.
`<T> T`
`readValueAs(TypeReference<?> valueTypeRef)`
Method to deserialize JSON content into a Java type, reference to which is passed as argument.
`<T> T`
`readValueAs(Class<T> valueType)`
Method to deserialize JSON content into a non-container type (it can be an array type, however): typically a bean, array or a wrapper type (like `Boolean`).
`<T extends TreeNode>
T`
`readValueAsTree()`
Method to deserialize JSON content into equivalent "tree model", represented by root `TreeNode` of resulting model.
`<T> Iterator<T>`
`readValuesAs(TypeReference<T> valueTypeRef)`
Method for reading sequence of Objects from parser stream, all with same specified value type.
`<T> Iterator<T>`
`readValuesAs(Class<T> valueType)`
Method for reading sequence of Objects from parser stream, all with same specified value type.
`int`
`releaseBuffered(OutputStream out)`
Method that can be called to push back any content that has been read but not consumed by the parser.
`int`
`releaseBuffered(Writer w)`
Method that can be called to push back any content that has been read but not consumed by the parser.
`boolean`
`requiresCustomCodec()`
Method that can be called to determine if a custom `ObjectCodec` is needed for binding data parsed using `JsonParser` constructed by this factory (which typically also implies the same for serialization with `JsonGenerator`).
`abstract void`
`setCodec(ObjectCodec oc)`
Setter that allows defining `ObjectCodec` associated with this parser, if any.
`void`
`setCurrentValue(Object v)`
Alias for `assignCurrentValue(java.lang.Object)`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).
`JsonParser`
`setFeatureMask(int mask)`
Deprecated.
Since 2.7, use `overrideStdFeatures(int, int)` instead
`void`
`setRequestPayloadOnError(byte[] payload, String charset)`
Sets the byte[] request payload and the charset
`void`
`setRequestPayloadOnError(RequestPayload payload)`
Sets the payload to be passed if `JsonParseException` is thrown.
`void`
`setRequestPayloadOnError(String payload)`
Sets the String request payload
`void`
`setSchema(FormatSchema schema)`
Method to call to make this parser use specified schema.
`abstract JsonParser`
`skipChildren()`
Method that will skip all child tokens of an array or object token that the parser currently points to, iff stream points to `JsonToken.START_OBJECT` or `JsonToken.START_ARRAY`.
`StreamReadConstraints`
`streamReadConstraints()`
Get the constraints to apply when performing streaming reads.
`abstract Version`
`version()`
Accessor for getting version of the core package, given a parser instance.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### DEFAULT_READ_CAPABILITIES

protected static final JacksonFeatureSet<StreamReadCapability> DEFAULT_READ_CAPABILITIES
Default set of `StreamReadCapability`ies that may be used as basis for format-specific readers (or as bogus instance if non-null set needs to be passed).

Since:
  2.12

### _features

protected int _features
Bit flag composed of bits that indicate which `JsonParser.Feature`s are enabled.

### _requestPayload

protected transient RequestPayload _requestPayload
Optional container that holds the request payload which will be displayed on JSON parsing error.

Since:
  2.8

## Constructor Details

### JsonParser

protected JsonParser()

### JsonParser

protected JsonParser(int features)

## Method Details

### getCodec

public abstract ObjectCodec getCodec()
Accessor for `ObjectCodec` associated with this parser, if any. Codec is used by `readValueAs(Class)` method (and its variants).

Returns:
  Codec assigned to this parser, if any; `null` if none

### setCodec

public abstract void setCodec(ObjectCodec oc)
Setter that allows defining `ObjectCodec` associated with this parser, if any. Codec is used by `readValueAs(Class)` method (and its variants).

Parameters:
  `oc` - Codec to assign, if any; `null` if none

### getInputSource

public Object getInputSource()
Method that can be used to get access to object that is used to access input being parsed; this is usually either `InputStream` or `Reader`, depending on what parser was constructed with. Note that returned value may be null in some cases; including case where parser implementation does not want to exposed raw source to caller. In cases where input has been decorated, object returned here is the decorated version; this allows some level of interaction between users of parser and decorator object.

In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

Returns:
  Input source this parser was configured with

### setRequestPayloadOnError

public void setRequestPayloadOnError(RequestPayload payload)
Sets the payload to be passed if `JsonParseException` is thrown.

Parameters:
  `payload` - Payload to pass
Since:
  2.8

### setRequestPayloadOnError

public void setRequestPayloadOnError(byte[] payload, String charset)
Sets the byte[] request payload and the charset

Parameters:
  `payload` - Payload to pass
  `charset` - Character encoding for (lazily) decoding payload
Since:
  2.8

### setRequestPayloadOnError

public void setRequestPayloadOnError(String payload)
Sets the String request payload

Parameters:
  `payload` - Payload to pass
Since:
  2.8

### streamReadConstraints

public StreamReadConstraints streamReadConstraints()
Get the constraints to apply when performing streaming reads.

Returns:
  Read constraints used by this parser
Since:
  2.15

### setSchema

public void setSchema(FormatSchema schema)
Method to call to make this parser use specified schema. Method must be called before trying to parse any content, right after parser instance has been created. Note that not all parsers support schemas; and those that do usually only accept specific types of schemas: ones defined for data format parser can read.

If parser does not support specified schema, `UnsupportedOperationException` is thrown.

Parameters:
  `schema` - Schema to use
Throws:
  `UnsupportedOperationException` - if parser does not support schema

### getSchema

public FormatSchema getSchema()
Method for accessing Schema that this parser uses, if any. Default implementation returns null.

Returns:
  Schema in use by this parser, if any; `null` if none
Since:
  2.1

### canUseSchema

public boolean canUseSchema(FormatSchema schema)
Method that can be used to verify that given schema can be used with this parser (using `setSchema(com.fasterxml.jackson.core.FormatSchema)`).

Parameters:
  `schema` - Schema to check
Returns:
  True if this parser can use given schema; false if not

### requiresCustomCodec

public boolean requiresCustomCodec()
Method that can be called to determine if a custom `ObjectCodec` is needed for binding data parsed using `JsonParser` constructed by this factory (which typically also implies the same for serialization with `JsonGenerator`).

Returns:
  True if format-specific codec is needed with this parser; false if a general `ObjectCodec` is enough
Since:
  2.1

### canParseAsync

public boolean canParseAsync()
Method that can be called to determine if this parser instance uses non-blocking ("asynchronous") input access for decoding or not. Access mode is determined by earlier calls via `JsonFactory`; it may not be changed after construction.

If non-blocking decoding is (@code true}, it is possible to call `getNonBlockingInputFeeder()` to obtain object to use for feeding input; otherwise (`false` returned) input is read by blocking

Returns:
  True if this is a non-blocking ("asynchronous") parser
Since:
  2.9

### getNonBlockingInputFeeder

public NonBlockingInputFeeder getNonBlockingInputFeeder()
Method that will either return a feeder instance (if parser uses non-blocking, aka asynchronous access); or `null` for parsers that use blocking I/O.

Returns:
  Input feeder to use with non-blocking (async) parsing
Since:
  2.9

### getReadCapabilities

public JacksonFeatureSet<StreamReadCapability> getReadCapabilities()
Accessor for getting metadata on capabilities of this parser, based on underlying data format being read (directly or indirectly).

Returns:
  Set of read capabilities for content to read via this parser
Since:
  2.12

### version

public abstract Version version()
Accessor for getting version of the core package, given a parser instance. Left for sub-classes to implement.

Specified by:
  `version` in interface `Versioned`
Returns:
  Version of this generator (derived from version declared for `jackson-core` jar that contains the class

### close

public abstract void close() throws IOException
Closes the parser so that no further iteration or data access can be made; will also close the underlying input source if parser either owns the input source, or feature `JsonParser.Feature.AUTO_CLOSE_SOURCE` is enabled. Whether parser owns the input source depends on factory method that was used to construct instance (so check `JsonFactory` for details, but the general idea is that if caller passes in closable resource (such as `InputStream` or `Reader`) parser does NOT own the source; but if it passes a reference (such as `File` or `URL` and creates stream or reader it does own them.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Throws:
  `IOException` - if there is either an underlying I/O problem

### isClosed

public abstract boolean isClosed()
Method that can be called to determine whether this parser is closed or not. If it is closed, no new tokens can be retrieved by calling `nextToken()` (and the underlying stream may be closed). Closing may be due to an explicit call to `close()` or because parser has encountered end of input.

Returns:
  `True` if this parser instance has been closed

### getParsingContext

public abstract JsonStreamContext getParsingContext()
Method that can be used to access current parsing context reader is in. There are 3 different types: root, array and object contexts, with slightly different available information. Contexts are hierarchically nested, and can be used for example for figuring out part of the input document that correspond to specific array or object (for highlighting purposes, or error reporting). Contexts can also be used for simple xpath-like matching of input, if so desired.

Returns:
  Stream input context (`JsonStreamContext`) associated with this parser

### currentLocation

public JsonLocation currentLocation()
Method that returns location of the last processed input unit (character or byte) from the input; usually for error reporting purposes.

Note that the location is not guaranteed to be accurate (although most implementation will try their best): some implementations may only report specific boundary locations (start or end locations of tokens) and others only return `JsonLocation.NA` due to not having access to input location information (when delegating actual decoding work to other library)

Returns:
  Location of the last processed input unit (byte or character)
Since:
  2.13

### currentTokenLocation

public JsonLocation currentTokenLocation()
Method that return the starting location of the current (most recently returned) token; that is, the position of the first input unit (character or byte) from input that starts the current token.

Note that the location is not guaranteed to be accurate (although most implementation will try their best): some implementations may only return `JsonLocation.NA` due to not having access to input location information (when delegating actual decoding work to other library)

Returns:
  Starting location of the token parser currently points to
Since:
  2.13 (will eventually replace `getTokenLocation()`)

### getCurrentLocation

public abstract JsonLocation getCurrentLocation()
Alias for `currentLocation()`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).

Returns:
  Location of the last processed input unit (byte or character)

### getTokenLocation

public abstract JsonLocation getTokenLocation()
Alias for `currentTokenLocation()`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).

Returns:
  Starting location of the token parser currently points to

### currentValue

public Object currentValue()
Helper method, usually equivalent to: `getParsingContext().getCurrentValue();`

Note that "current value" is NOT populated (or used) by Streaming parser; it is only used by higher-level data-binding functionality. The reason it is included here is that it can be stored and accessed hierarchically, and gets passed through data-binding.

Returns:
  "Current value" associated with the current input context (state) of this parser
Since:
  2.13 (added as replacement for older `getCurrentValue()`

### assignCurrentValue

public void assignCurrentValue(Object v)
Helper method, usually equivalent to: `getParsingContext().setCurrentValue(v);`

Parameters:
  `v` - Current value to assign for the current input context of this parser
Since:
  2.13 (added as replacement for older `setCurrentValue(java.lang.Object)`

### getCurrentValue

public Object getCurrentValue()
Alias for `currentValue()`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).

Returns:
  Location of the last processed input unit (byte or character)

### setCurrentValue

public void setCurrentValue(Object v)
Alias for `assignCurrentValue(java.lang.Object)`, to be deprecated in later Jackson 2.x versions (and removed from Jackson 3.0).

Parameters:
  `v` - Current value to assign for the current input context of this parser

### releaseBuffered

public int releaseBuffered(OutputStream out) throws IOException
Method that can be called to push back any content that has been read but not consumed by the parser. This is usually done after reading all content of interest using parser. Content is released by writing it to given stream if possible; if underlying input is byte-based it can released, if not (char-based) it can not.

Parameters:
  `out` - OutputStream to which buffered, undecoded content is written to
Returns:
  -1 if the underlying content source is not byte based (that is, input can not be sent to `OutputStream`; otherwise number of bytes released (0 if there was nothing to release)
Throws:
  `IOException` - if write to stream threw exception

### releaseBuffered

public int releaseBuffered(Writer w) throws IOException
Method that can be called to push back any content that has been read but not consumed by the parser. This is usually done after reading all content of interest using parser. Content is released by writing it to given writer if possible; if underlying input is char-based it can released, if not (byte-based) it can not.

Parameters:
  `w` - Writer to which buffered but unprocessed content is written to
Returns:
  -1 if the underlying content source is not char-based (that is, input can not be sent to `Writer`; otherwise number of chars released (0 if there was nothing to release)
Throws:
  `IOException` - if write using Writer threw exception

### enable

public JsonParser enable(JsonParser.Feature f)
Method for enabling specified parser feature (check `JsonParser.Feature` for list of features)

Parameters:
  `f` - Feature to enable
Returns:
  This parser, to allow call chaining

### disable

public JsonParser disable(JsonParser.Feature f)
Method for disabling specified feature (check `JsonParser.Feature` for list of features)

Parameters:
  `f` - Feature to disable
Returns:
  This parser, to allow call chaining

### configure

public JsonParser configure(JsonParser.Feature f, boolean state)
Method for enabling or disabling specified feature (check `JsonParser.Feature` for list of features)

Parameters:
  `f` - Feature to enable or disable
  `state` - Whether to enable feature (`true`) or disable (`false`)
Returns:
  This parser, to allow call chaining

### isEnabled

public boolean isEnabled(JsonParser.Feature f)
Method for checking whether specified `JsonParser.Feature` is enabled.

Parameters:
  `f` - Feature to check
Returns:
  `True` if feature is enabled; `false` otherwise

### isEnabled

public boolean isEnabled(StreamReadFeature f)
Method for checking whether specified `JsonParser.Feature` is enabled.

Parameters:
  `f` - Feature to check
Returns:
  `True` if feature is enabled; `false` otherwise
Since:
  2.10

### getFeatureMask

public int getFeatureMask()
Bulk access method for getting state of all standard `JsonParser.Feature`s.

Returns:
  Bit mask that defines current states of all standard `JsonParser.Feature`s.
Since:
  2.3

### setFeatureMask

@Deprecated public JsonParser setFeatureMask(int mask)
Deprecated.
Since 2.7, use `overrideStdFeatures(int, int)` instead
Bulk set method for (re)setting states of all standard `JsonParser.Feature`s

Parameters:
  `mask` - Bit mask that defines set of features to enable
Returns:
  This parser, to allow call chaining
Since:
  2.3

### overrideStdFeatures

public JsonParser overrideStdFeatures(int values, int mask)
Bulk set method for (re)setting states of features specified by `mask`. Functionally equivalent to `int oldState = getFeatureMask(); int newState = (oldState & ~mask) | (values & mask); setFeatureMask(newState);` but preferred as this lets caller more efficiently specify actual changes made.

Parameters:
  `values` - Bit mask of set/clear state for features to change
  `mask` - Bit mask of features to change
Returns:
  This parser, to allow call chaining
Since:
  2.6

### getFormatFeatures

public int getFormatFeatures()
Bulk access method for getting state of all `FormatFeature`s, format-specific on/off configuration settings.

Returns:
  Bit mask that defines current states of all standard `FormatFeature`s.
Since:
  2.6

### overrideFormatFeatures

public JsonParser overrideFormatFeatures(int values, int mask)
Bulk set method for (re)setting states of `FormatFeature`s, by specifying values (set / clear) along with a mask, to determine which features to change, if any.

Default implementation will simply throw an exception to indicate that the parser implementation does not support any `FormatFeature`s.

Parameters:
  `values` - Bit mask of set/clear state for features to change
  `mask` - Bit mask of features to change
Returns:
  This parser, to allow call chaining
Since:
  2.6

### nextToken

public abstract JsonToken nextToken() throws IOException
Main iteration method, which will advance stream enough to determine type of the next token, if any. If none remaining (stream has no content other than possible white space before ending), null will be returned.

Returns:
  Next token from the stream, if any found, or null to indicate end-of-input
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### nextValue

public abstract JsonToken nextValue() throws IOException
Iteration method that will advance stream enough to determine type of the next token that is a value type (including JSON Array and Object start/end markers). Or put another way, nextToken() will be called once, and if `JsonToken.FIELD_NAME` is returned, another time to get the value for the field. Method is most useful for iterating over value entries of JSON objects; field name will still be available by calling `getCurrentName()` when parser points to the value.

Returns:
  Next non-field-name token from the stream, if any found, or null to indicate end-of-input (or, for non-blocking parsers, `JsonToken.NOT_AVAILABLE` if no tokens were available yet)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### nextFieldName

public boolean nextFieldName(SerializableString str) throws IOException
Method that fetches next token (as if calling `nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME` with specified name and returns result of that comparison. It is functionally equivalent to:

      return (nextToken() == JsonToken.FIELD_NAME) && str.getValue().equals(getCurrentName());

but may be faster for parser to verify, and can therefore be used if caller expects to get such a property name from input next.

Parameters:
  `str` - Property name to compare next token to (if next token is `JsonToken.FIELD_NAME`)
Returns:
  `True` if parser advanced to `JsonToken.FIELD_NAME` with specified name; `false` otherwise (different token or non-matching name)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### nextFieldName

public String nextFieldName() throws IOException
Method that fetches next token (as if calling `nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME`; if it is, returns same as `getCurrentName()`, otherwise null.

Returns:
  Name of the the `JsonToken.FIELD_NAME` parser advanced to, if any; `null` if next token is of some other type
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
Since:
  2.5

### nextTextValue

public String nextTextValue() throws IOException
Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_STRING` returns contained String value; otherwise returns null. It is functionally equivalent to:

      return (nextToken() == JsonToken.VALUE_STRING) ? getText() : null;

but may be faster for parser to process, and can therefore be used if caller expects to get a String value next from input.

Returns:
  Text value of the `JsonToken.VALUE_STRING` token parser advanced to; or `null` if next token is of some other type
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### nextIntValue

public int nextIntValue(int defaultValue) throws IOException
Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 32-bit int value; otherwise returns specified default value It is functionally equivalent to:

      return (nextToken() == JsonToken.VALUE_NUMBER_INT) ? getIntValue() : defaultValue;

but may be faster for parser to process, and can therefore be used if caller expects to get an int value next from input.

NOTE: value checks are performed similar to `getIntValue()`

Parameters:
  `defaultValue` - Value to return if next token is NOT of type `JsonToken.VALUE_NUMBER_INT`
Returns:
  Integer (`int`) value of the `JsonToken.VALUE_NUMBER_INT` token parser advanced to; or `defaultValue` if next token is of some other type
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
  `InputCoercionException` - if integer number does not fit in Java `int`

### nextLongValue

public long nextLongValue(long defaultValue) throws IOException
Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 64-bit long value; otherwise returns specified default value It is functionally equivalent to:

      return (nextToken() == JsonToken.VALUE_NUMBER_INT) ? getLongValue() : defaultValue;

but may be faster for parser to process, and can therefore be used if caller expects to get a long value next from input.

NOTE: value checks are performed similar to `getLongValue()`

Parameters:
  `defaultValue` - Value to return if next token is NOT of type `JsonToken.VALUE_NUMBER_INT`
Returns:
  `long` value of the `JsonToken.VALUE_NUMBER_INT` token parser advanced to; or `defaultValue` if next token is of some other type
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
  `InputCoercionException` - if integer number does not fit in Java `long`

### nextBooleanValue

public Boolean nextBooleanValue() throws IOException
Method that fetches next token (as if calling `nextToken()`) and if it is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE` returns matching Boolean value; otherwise return null. It is functionally equivalent to:

      JsonToken t = nextToken();
      if (t == JsonToken.VALUE_TRUE) return Boolean.TRUE;
      if (t == JsonToken.VALUE_FALSE) return Boolean.FALSE;
      return null;

but may be faster for parser to process, and can therefore be used if caller expects to get a Boolean value next from input.

Returns:
  `Boolean` value of the `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE` token parser advanced to; or `null` if next token is of some other type
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### skipChildren

public abstract JsonParser skipChildren() throws IOException
Method that will skip all child tokens of an array or object token that the parser currently points to, iff stream points to `JsonToken.START_OBJECT` or `JsonToken.START_ARRAY`. If not, it will do nothing. After skipping, stream will point to matching `JsonToken.END_OBJECT` or `JsonToken.END_ARRAY` (possibly skipping nested pairs of START/END OBJECT/ARRAY tokens as well as value tokens). The idea is that after calling this method, application will call `nextToken()` to point to the next available token, if any.

Returns:
  This parser, to allow call chaining
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### finishToken

public void finishToken() throws IOException
Method that may be used to force full handling of the current token so that even if lazy processing is enabled, the whole contents are read for possible retrieval. This is usually used to ensure that the token end location is available, as well as token contents (similar to what calling, say `getTextCharacters()`, would achieve).

Note that for many dataformat implementations this method will not do anything; this is the default implementation unless overridden by sub-classes.

Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
Since:
  2.8

### currentToken

public JsonToken currentToken()
Accessor to find which token parser currently points to, if any; null will be returned if none. If return value is non-null, data associated with the token is available via other accessor methods.

Returns:
  Type of the token this parser currently points to, if any: null before any tokens have been read, and after end-of-input has been encountered, as well as if the current token has been explicitly cleared.
Since:
  2.8

### currentTokenId

public int currentTokenId()
Method similar to `getCurrentToken()` but that returns an `int` instead of `JsonToken` (enum value).

Use of int directly is typically more efficient on switch statements, so this method may be useful when building low-overhead codecs. Note, however, that effect may not be big enough to matter: make sure to profile performance before deciding to use this method.

Returns:
  `int` matching one of constants from `JsonTokenId`.
Since:
  2.8

### getCurrentToken

public abstract JsonToken getCurrentToken()
Alias for `currentToken()`, may be deprecated sometime after Jackson 2.13 (will be removed from 3.0).

Returns:
  Type of the token this parser currently points to, if any: null before any tokens have been read, and

### getCurrentTokenId

@Deprecated public abstract int getCurrentTokenId()
Deprecated.
Since 2.12 use `currentTokenId()` instead
Deprecated alias for `currentTokenId()`.

Returns:
  `int` matching one of constants from `JsonTokenId`.

### hasCurrentToken

public abstract boolean hasCurrentToken()
Method for checking whether parser currently points to a token (and data for that token is available). Equivalent to check for `parser.getCurrentToken() != null`.

Returns:
  True if the parser just returned a valid token via `nextToken()`; false otherwise (parser was just constructed, encountered end-of-input and returned null from `nextToken()`, or the token has been consumed)

### hasTokenId

public abstract boolean hasTokenId(int id)
Method that is functionally equivalent to: `return currentTokenId() == id` but may be more efficiently implemented.

Note that no traversal or conversion is performed; so in some cases calling method like `isExpectedStartArrayToken()` is necessary instead.

Parameters:
  `id` - Token id to match (from (@link JsonTokenId})
Returns:
  `True` if the parser current points to specified token
Since:
  2.5

### hasToken

public abstract boolean hasToken(JsonToken t)
Method that is functionally equivalent to: `return currentToken() == t` but may be more efficiently implemented.

Note that no traversal or conversion is performed; so in some cases calling method like `isExpectedStartArrayToken()` is necessary instead.

Parameters:
  `t` - Token to match
Returns:
  `True` if the parser current points to specified token
Since:
  2.6

### isExpectedStartArrayToken

public boolean isExpectedStartArrayToken()
Specialized accessor that can be used to verify that the current token indicates start array (usually meaning that current token is `JsonToken.START_ARRAY`) when start array is expected. For some specialized parsers this can return true for other cases as well; this is usually done to emulate arrays in cases underlying format is ambiguous (XML, for example, has no format-level difference between Objects and Arrays; it just has elements).

Default implementation is equivalent to:

       currentToken() == JsonToken.START_ARRAY

but may be overridden by custom parser implementations.

Returns:
  True if the current token can be considered as a start-array marker (such `JsonToken.START_ARRAY`); `false` if not

### isExpectedStartObjectToken

public boolean isExpectedStartObjectToken()
Similar to `isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.START_OBJECT`.

Returns:
  True if the current token can be considered as a start-array marker (such `JsonToken.START_OBJECT`); `false` if not
Since:
  2.5

### isExpectedNumberIntToken

public boolean isExpectedNumberIntToken()
Similar to `isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.VALUE_NUMBER_INT`.

The initial use case is for XML backend to efficiently (attempt to) coerce textual content into numbers.

Returns:
  True if the current token can be considered as a start-array marker (such `JsonToken.VALUE_NUMBER_INT`); `false` if not
Since:
  2.12

### isNaN

public boolean isNaN() throws IOException
Access for checking whether current token is a numeric value token, but one that is of "not-a-number" (NaN) variety (including both "NaN" AND positive/negative infinity!): not supported by all formats, but often supported for `JsonToken.VALUE_NUMBER_FLOAT`. NOTE: roughly equivalent to calling `!Double.isFinite()` on value you would get from calling `getDoubleValue()`.

Returns:
  `True` if the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` but represents a "Not a Number"; `false` for other tokens and regular floating-point numbers
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
Since:
  2.9

### clearCurrentToken

public abstract void clearCurrentToken()
Method called to "consume" the current token by effectively removing it so that `hasCurrentToken()` returns false, and `getCurrentToken()` null). Cleared token value can still be accessed by calling `getLastClearedToken()` (if absolutely needed), but usually isn't.

Method was added to be used by the optional data binder, since it has to be able to consume last token used for binding (so that it will not be used again).

### getLastClearedToken

public abstract JsonToken getLastClearedToken()
Method that can be called to get the last token that was cleared using `clearCurrentToken()`. This is not necessarily the latest token read. Will return null if no tokens have been cleared, or if parser has been closed.

Returns:
  Last cleared token, if any; `null` otherwise

### overrideCurrentName

public abstract void overrideCurrentName(String name)
Method that can be used to change what is considered to be the current (field) name. May be needed to support non-JSON data formats or unusual binding conventions; not needed for typical processing.

Note that use of this method should only be done as sort of last resort, as it is a work-around for regular operation.

Parameters:
  `name` - Name to use as the current name; may be null.

### getCurrentName

public abstract String getCurrentName() throws IOException
Alias of `currentName()`.

Returns:
  Name of the current field in the parsing context
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### currentName

public String currentName() throws IOException
Method that can be called to get the name associated with the current token: for `JsonToken.FIELD_NAME`s it will be the same as what `getText()` returns; for field values it will be preceding field name; and for others (array values, root-level values) null.

Returns:
  Name of the current field in the parsing context
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
Since:
  2.10

### getText

public abstract String getText() throws IOException
Method for accessing textual representation of the current token; if no current token (before first call to `nextToken()`, or after encountering end-of-input), returns null. Method can be called for any token type.

Returns:
  Textual value associated with the current token (one returned by `nextToken()` or other iteration methods)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems, including if the text is too large, see `StreamReadConstraints.Builder.maxStringLength(int)`

### getText

public int getText(Writer writer) throws IOException, UnsupportedOperationException
Method to read the textual representation of the current token in chunks and pass it to the given Writer. Conceptually same as calling:

      writer.write(parser.getText());

but should typically be more efficient as longer content does need to be combined into a single `String` to return, and write can occur directly from intermediate buffers Jackson uses.

Parameters:
  `writer` - Writer to write textual content to
Returns:
  The number of characters written to the Writer
Throws:
  `IOException` - for low-level read issues or writes using passed `writer`, or `JsonParseException` for decoding problems
  `UnsupportedOperationException`
Since:
  2.8

### getTextCharacters

public abstract char[] getTextCharacters() throws IOException
Method similar to `getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information. Note, however, that:

- Textual contents are not guaranteed to start at index 0 (rather, call `getTextOffset()`) to know the actual offset
- Length of textual contents may be less than the length of returned buffer: call `getTextLength()` for actual length of returned content.

Note that caller MUST NOT modify the returned character array in any way -- doing so may corrupt current parser state and render parser instance useless.

The only reason to call this method (over `getText()`) is to avoid construction of a String object (which will make a copy of contents).

Returns:
  Buffer that contains the current textual value (but not necessarily at offset 0, and not necessarily until the end of buffer)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems, including if the text is too large, see `StreamReadConstraints.Builder.maxStringLength(int)`

### getTextLength

public abstract int getTextLength() throws IOException
Accessor used with `getTextCharacters()`, to know length of String stored in returned buffer.

Returns:
  Number of characters within buffer returned by `getTextCharacters()` that are part of textual content of the current token.
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getTextOffset

public abstract int getTextOffset() throws IOException
Accessor used with `getTextCharacters()`, to know offset of the first text content character within buffer.

Returns:
  Offset of the first character within buffer returned by `getTextCharacters()` that is part of textual content of the current token.
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### hasTextCharacters

public abstract boolean hasTextCharacters()
Method that can be used to determine whether calling of `getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.

Default implementation simply returns false since only actual implementation class has knowledge of its internal buffering state. Implementations are strongly encouraged to properly override this method, to allow efficient copying of content by other code.

Returns:
  True if parser currently has character array that can be efficiently returned via `getTextCharacters()`; false means that it may or may not exist

### getNumberValue

public abstract Number getNumberValue() throws IOException
Generic number value accessor method that will work for all kinds of numeric values. It will return the optimal (simplest/smallest possible) wrapper object that can express the numeric value just parsed.

Returns:
  Numeric value of the current token in its most optimal representation
Throws:
  `IOException` - Problem with access: `JsonParseException` if the current token is not numeric, or if decoding of the value fails (invalid format for numbers); plain `IOException` if underlying content read fails (possible if values are extracted lazily)

### getNumberValueExact

public Number getNumberValueExact() throws IOException
Method similar to `getNumberValue()` with the difference that for floating-point numbers value returned may be `BigDecimal` if the underlying format does not store floating-point numbers using native representation: for example, textual formats represent numbers as Strings (which are 10-based), and conversion to `Double` is potentially lossy operation.

Default implementation simply returns `getNumberValue()`

Returns:
  Numeric value of the current token using most accurate representation
Throws:
  `IOException` - Problem with access: `JsonParseException` if the current token is not numeric, or if decoding of the value fails (invalid format for numbers); plain `IOException` if underlying content read fails (possible if values are extracted lazily)
Since:
  2.12

### getNumberValueDeferred

public Object getNumberValueDeferred() throws IOException
Method similar to `getNumberValue()` but that returns either same `Number` value as `getNumberValue()` (if already decoded), or `String` representation of as-of-yet undecoded number. Typically textual formats allow deferred decoding from String, whereas binary formats either decode numbers eagerly or have binary representation from which to decode value to return.

Same constraints apply to calling this method as to `getNumberValue()`: current token must be either `JsonToken.VALUE_NUMBER_INT` or `JsonToken.VALUE_NUMBER_FLOAT`; otherwise an exception is thrown

Default implementation simply returns `getNumberValue()`

Returns:
  Either `Number` (for already decoded numbers) or `String` (for deferred decoding).
Throws:
  `IOException` - Problem with access: `JsonParseException` if the current token is not numeric, or if decoding of the value fails (invalid format for numbers); plain `IOException` if underlying content read fails (possible if values are extracted lazily)
Since:
  2.15

### getNumberType

public abstract JsonParser.NumberType getNumberType() throws IOException
If current token is of type `JsonToken.VALUE_NUMBER_INT` or `JsonToken.VALUE_NUMBER_FLOAT`, returns one of `JsonParser.NumberType` constants; otherwise returns null.

Returns:
  Type of current number, if parser points to numeric token; `null` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getByteValue

public byte getByteValue() throws IOException
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java byte primitive type. Note that in addition to "natural" input range of `[-128, 127]`, this also allows "unsigned 8-bit byte" values `[128, 255]`: but for this range value will be translated by truncation, leading to sign change.

It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `getDoubleValue()` and then casting; except for possible overflow/underflow exception.

Note: if the resulting integer value falls outside range of `[-128, 255]`, a `InputCoercionException` will be thrown to indicate numeric overflow/underflow.

Returns:
  Current number value as `byte` (if numeric token within range of `[-128, 255]`); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getShortValue

public short getShortValue() throws IOException
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java short primitive type. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `getDoubleValue()` and then casting; except for possible overflow/underflow exception.

Note: if the resulting integer value falls outside range of Java short, a `InputCoercionException` will be thrown to indicate numeric overflow/underflow.

Returns:
  Current number value as `short` (if numeric token within Java 16-bit signed `short` range); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getIntValue

public abstract int getIntValue() throws IOException
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a value of Java int primitive type. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `getDoubleValue()` and then casting; except for possible overflow/underflow exception.

Note: if the resulting integer value falls outside range of Java `int`, a `InputCoercionException` may be thrown to indicate numeric overflow/underflow.

Returns:
  Current number value as `int` (if numeric token within Java 32-bit signed `int` range); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getLongValue

public abstract long getLongValue() throws IOException
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can be expressed as a Java long primitive type. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `getDoubleValue()` and then casting to int; except for possible overflow/underflow exception.

Note: if the token is an integer, but its value falls outside of range of Java long, a `InputCoercionException` may be thrown to indicate numeric overflow/underflow.

Returns:
  Current number value as `long` (if numeric token within Java 32-bit signed `long` range); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getBigIntegerValue

public abstract BigInteger getBigIntegerValue() throws IOException
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_INT` and it can not be used as a Java long primitive type due to its magnitude. It can also be called for `JsonToken.VALUE_NUMBER_FLOAT`; if so, it is equivalent to calling `getDecimalValue()` and then constructing a `BigInteger` from that value.

Returns:
  Current number value as `BigInteger` (if numeric token); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getFloatValue

public abstract float getFloatValue() throws IOException
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java float primitive type. It can also be called for `JsonToken.VALUE_NUMBER_INT`; if so, it is equivalent to calling `getLongValue()` and then casting; except for possible overflow/underflow exception.

Note: if the value falls outside of range of Java float, a `InputCoercionException` will be thrown to indicate numeric overflow/underflow.

Returns:
  Current number value as `float` (if numeric token within Java `float` range); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getDoubleValue

public abstract double getDoubleValue() throws IOException
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` and it can be expressed as a Java double primitive type. It can also be called for `JsonToken.VALUE_NUMBER_INT`; if so, it is equivalent to calling `getLongValue()` and then casting; except for possible overflow/underflow exception.

Note: if the value falls outside of range of Java double, a `InputCoercionException` will be thrown to indicate numeric overflow/underflow.

Returns:
  Current number value as `double` (if numeric token within Java `double` range); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getDecimalValue

public abstract BigDecimal getDecimalValue() throws IOException
Numeric accessor that can be called when the current token is of type `JsonToken.VALUE_NUMBER_FLOAT` or `JsonToken.VALUE_NUMBER_INT`. No under/overflow exceptions are ever thrown.

Returns:
  Current number value as `BigDecimal` (if numeric token); otherwise exception thrown
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getBooleanValue

public boolean getBooleanValue() throws IOException
Convenience accessor that can be called when the current token is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE`, to return matching `boolean` value. If the current token is of some other type, `JsonParseException` will be thrown

Returns:
  `True` if current token is `JsonToken.VALUE_TRUE`, `false` if current token is `JsonToken.VALUE_FALSE`; otherwise throws `JsonParseException`
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getEmbeddedObject

public Object getEmbeddedObject() throws IOException
Accessor that can be called if (and only if) the current token is `JsonToken.VALUE_EMBEDDED_OBJECT`. For other token types, null is returned.

Note: only some specialized parser implementations support embedding of objects (usually ones that are facades on top of non-streaming sources, such as object trees). One exception is access to binary content (whether via base64 encoding or not) which typically is accessible using this method, as well as `getBinaryValue()`.

Returns:
  Embedded value (usually of "native" type supported by format) for the current token, if any; `null otherwise`
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getBinaryValue

public abstract byte[] getBinaryValue(Base64Variant bv) throws IOException
Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value. It works similar to getting String value via `getText()` and decoding result (except for decoding part), but should be significantly more performant.

Note that non-decoded textual contents of the current token are not guaranteed to be accessible after this method is called. Current implementation, for example, clears up textual content during decoding. Decoded binary content, however, will be retained until parser is advanced to the next event.

Parameters:
  `bv` - Expected variant of base64 encoded content (see `Base64Variants` for definitions of "standard" variants).
Returns:
  Decoded binary data
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getBinaryValue

public byte[] getBinaryValue() throws IOException
Convenience alternative to `getBinaryValue(Base64Variant)` that defaults to using `Base64Variants.getDefaultVariant()` as the default encoding.

Returns:
  Decoded binary data
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### readBinaryValue

public int readBinaryValue(OutputStream out) throws IOException
Method that can be used as an alternative to `getBigIntegerValue()`, especially when value can be large. The main difference (beyond method of returning content using `OutputStream` instead of as byte array) is that content will NOT remain accessible after method returns: any content processed will be consumed and is not buffered in any way. If caller needs buffering, it has to implement it.

Parameters:
  `out` - Output stream to use for passing decoded binary data
Returns:
  Number of bytes that were decoded and written via `OutputStream`
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
Since:
  2.1

### readBinaryValue

public int readBinaryValue(Base64Variant bv, OutputStream out) throws IOException
Similar to `readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.

Parameters:
  `bv` - base64 variant to use
  `out` - Output stream to use for passing decoded binary data
Returns:
  Number of bytes that were decoded and written via `OutputStream`
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
Since:
  2.1

### getValueAsInt

public int getValueAsInt() throws IOException
Method that will try to convert value of current token to a Java `int` value. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation can not be converted to an int (including structured type markers like start/end Object/Array) default value of 0 will be returned; no exceptions are thrown.

Returns:
  `int` value current token is converted to, if possible; exception thrown otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getValueAsInt

public int getValueAsInt(int def) throws IOException
Method that will try to convert value of current token to a int. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation can not be converted to an int (including structured type markers like start/end Object/Array) specified def will be returned; no exceptions are thrown.

Parameters:
  `def` - Default value to return if conversion to `int` is not possible
Returns:
  `int` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getValueAsLong

public long getValueAsLong() throws IOException
Method that will try to convert value of current token to a long. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation can not be converted to a long (including structured type markers like start/end Object/Array) default value of 0L will be returned; no exceptions are thrown.

Returns:
  `long` value current token is converted to, if possible; exception thrown otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getValueAsLong

public long getValueAsLong(long def) throws IOException
Method that will try to convert value of current token to a long. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

If representation can not be converted to a long (including structured type markers like start/end Object/Array) specified def will be returned; no exceptions are thrown.

Parameters:
  `def` - Default value to return if conversion to `long` is not possible
Returns:
  `long` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getValueAsDouble

public double getValueAsDouble() throws IOException
Method that will try to convert value of current token to a Java double. Numbers are coerced using default Java rules; booleans convert to 0.0 (false) and 1.0 (true), and Strings are parsed using default Java language floating point parsing rules.

If representation can not be converted to a double (including structured types like Objects and Arrays), default value of 0.0 will be returned; no exceptions are thrown.

Returns:
  `double` value current token is converted to, if possible; exception thrown otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getValueAsDouble

public double getValueAsDouble(double def) throws IOException
Method that will try to convert value of current token to a Java double. Numbers are coerced using default Java rules; booleans convert to 0.0 (false) and 1.0 (true), and Strings are parsed using default Java language floating point parsing rules.

If representation can not be converted to a double (including structured types like Objects and Arrays), specified def will be returned; no exceptions are thrown.

Parameters:
  `def` - Default value to return if conversion to `double` is not possible
Returns:
  `double` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getValueAsBoolean

public boolean getValueAsBoolean() throws IOException
Method that will try to convert value of current token to a boolean. JSON booleans map naturally; integer numbers other than 0 map to true, and 0 maps to false and Strings 'true' and 'false' map to corresponding values.

If representation can not be converted to a boolean value (including structured types like Objects and Arrays), default value of false will be returned; no exceptions are thrown.

Returns:
  `boolean` value current token is converted to, if possible; exception thrown otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getValueAsBoolean

public boolean getValueAsBoolean(boolean def) throws IOException
Method that will try to convert value of current token to a boolean. JSON booleans map naturally; integer numbers other than 0 map to true, and 0 maps to false and Strings 'true' and 'false' map to corresponding values.

If representation can not be converted to a boolean value (including structured types like Objects and Arrays), specified def will be returned; no exceptions are thrown.

Parameters:
  `def` - Default value to return if conversion to `boolean` is not possible
Returns:
  `boolean` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

### getValueAsString

public String getValueAsString() throws IOException
Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and `null` token), default value of null will be returned; no exceptions are thrown.

Returns:
  `String` value current token is converted to, if possible; `null` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
Since:
  2.1

### getValueAsString

public abstract String getValueAsString(String def) throws IOException
Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and `null` token), specified default value will be returned; no exceptions are thrown.

Parameters:
  `def` - Default value to return if conversion to `String` is not possible
Returns:
  `String` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
Since:
  2.1

### canReadObjectId

public boolean canReadObjectId()
Introspection method that may be called to see if the underlying data format supports some kind of Object Ids natively (many do not; for example, JSON doesn't).

Default implementation returns true; overridden by data formats that do support native Object Ids. Caller is expected to either use a non-native notation (explicit property or such), or fail, in case it can not use native object ids.

Returns:
  `True` if the format being read supports native Object Ids; `false` if not
Since:
  2.3

### canReadTypeId

public boolean canReadTypeId()
Introspection method that may be called to see if the underlying data format supports some kind of Type Ids natively (many do not; for example, JSON doesn't).

Default implementation returns true; overridden by data formats that do support native Type Ids. Caller is expected to either use a non-native notation (explicit property or such), or fail, in case it can not use native type ids.

Returns:
  `True` if the format being read supports native Type Ids; `false` if not
Since:
  2.3

### getObjectId

public Object getObjectId() throws IOException
Method that can be called to check whether current token (one that was just read) has an associated Object id, and if so, return it. Note that while typically caller should check with `canReadObjectId()` first, it is not illegal to call this method even if that method returns true; but if so, it will return null. This may be used to simplify calling code.

Default implementation will simply return null.

Returns:
  Native Object id associated with the current token, if any; `null` if none
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
Since:
  2.3

### getTypeId

public Object getTypeId() throws IOException
Method that can be called to check whether current token (one that was just read) has an associated type id, and if so, return it. Note that while typically caller should check with `canReadTypeId()` first, it is not illegal to call this method even if that method returns true; but if so, it will return null. This may be used to simplify calling code.

Default implementation will simply return null.

Returns:
  Native Type Id associated with the current token, if any; `null` if none
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
Since:
  2.3

### readValueAs

public <T> T readValueAs(Class<T> valueType) throws IOException
Method to deserialize JSON content into a non-container type (it can be an array type, however): typically a bean, array or a wrapper type (like `Boolean`). Note: method can only be called if the parser has an object codec assigned; this is true for parsers constructed by `MappingJsonFactory` (from "jackson-databind" jar) but not for `JsonFactory` (unless its `setCodec` method has been explicitly called).

This method may advance the event stream, for structured types the current token will be the closing end marker (END_ARRAY, END_OBJECT) of the bound structure. For non-structured Json types (and for `JsonToken.VALUE_EMBEDDED_OBJECT`) stream is not advanced.

Note: this method should NOT be used if the result type is a container (`Collection` or `Map`. The reason is that due to type erasure, key and value types can not be introspected when using this method.

Type Parameters:
  `T` - Nominal type parameter for value type
Parameters:
  `valueType` - Java type to read content as (passed to ObjectCodec that deserializes content)
Returns:
  Java value read from content
Throws:
  `IOException` - if there is either an underlying I/O problem or decoding issue at format layer

### readValueAs

public <T> T readValueAs(TypeReference<?> valueTypeRef) throws IOException
Method to deserialize JSON content into a Java type, reference to which is passed as argument. Type is passed using so-called "super type token" and specifically needs to be used if the root type is a parameterized (generic) container type. Note: method can only be called if the parser has an object codec assigned; this is true for parsers constructed by `MappingJsonFactory` (defined in 'jackson-databind' bundle) but not for `JsonFactory` (unless its `setCodec` method has been explicitly called).

This method may advance the event stream, for structured types the current token will be the closing end marker (END_ARRAY, END_OBJECT) of the bound structure. For non-structured Json types (and for `JsonToken.VALUE_EMBEDDED_OBJECT`) stream is not advanced.

Type Parameters:
  `T` - Nominal type parameter for value type
Parameters:
  `valueTypeRef` - Java type to read content as (passed to ObjectCodec that deserializes content)
Returns:
  Java value read from content
Throws:
  `IOException` - if there is either an underlying I/O problem or decoding issue at format layer

### readValuesAs

public <T> Iterator<T> readValuesAs(Class<T> valueType) throws IOException
Method for reading sequence of Objects from parser stream, all with same specified value type.

Type Parameters:
  `T` - Nominal type parameter for value type
Parameters:
  `valueType` - Java type to read content as (passed to ObjectCodec that deserializes content)
Returns:
  Iterator for reading multiple Java values from content
Throws:
  `IOException` - if there is either an underlying I/O problem or decoding issue at format layer

### readValuesAs

public <T> Iterator<T> readValuesAs(TypeReference<T> valueTypeRef) throws IOException
Method for reading sequence of Objects from parser stream, all with same specified value type.

Type Parameters:
  `T` - Nominal type parameter for value type
Parameters:
  `valueTypeRef` - Java type to read content as (passed to ObjectCodec that deserializes content)
Returns:
  Iterator for reading multiple Java values from content
Throws:
  `IOException` - if there is either an underlying I/O problem or decoding issue at format layer

### readValueAsTree

public <T extends TreeNode> T readValueAsTree() throws IOException
Method to deserialize JSON content into equivalent "tree model", represented by root `TreeNode` of resulting model. For JSON Arrays it will an array node (with child nodes), for objects object node (with child nodes), and for other types matching leaf node type. Empty or whitespace documents are null.

Type Parameters:
  `T` - Nominal type parameter for result node type (to reduce need for casting)
Returns:
  root of the document, or null if empty or whitespace.
Throws:
  `IOException` - if there is either an underlying I/O problem or decoding issue at format layer

### _codec

protected ObjectCodec _codec()

### _constructError

protected JsonParseException _constructError(String msg)
Helper method for constructing `JsonParseException`s based on current state of the parser

Parameters:
  `msg` - Base exception message to construct exception with
Returns:
  `JsonParseException` constructed

### _reportUnsupportedOperation

protected void _reportUnsupportedOperation()
Helper method to call for operations that are not supported by parser implementation.

Since:
  2.1

### _constructReadException

protected JsonParseException _constructReadException(String msg)
Helper method for constructing `JsonParseException` based on current state of the parser.

Parameters:
  `msg` - Base exception message to construct exception with
Returns:
  Read exception (of type `JsonParseException`) constructed
Since:
  2.13

### _constructReadException

protected JsonParseException _constructReadException(String msg, Object arg)

### _constructReadException

protected JsonParseException _constructReadException(String msg, Object arg1, Object arg2)

### _constructReadException

protected JsonParseException _constructReadException(String msg, Object arg1, Object arg2, Object arg3)

### _constructReadException

protected JsonParseException _constructReadException(String msg, Throwable t)
Helper method for constructing `JsonParseException` based on current state of the parser and indicating that the given `Throwable` is the root cause.

Parameters:
  `msg` - Base exception message to construct exception with
  `t` - Root cause to assign
Returns:
  Read exception (of type `JsonParseException`) constructed
Since:
  2.13